function krSlidingBaseEvent,event

compile_opt idl2

return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBaseEvent,event

compile_opt idl2

userBase = widget_info(event.top,find_by_uname='krsbub')
widget_control, userBase, get_uvalue=object
widget_control,event.id,get_uvalue=method
call_method, method, object, event

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBaseRealize, baseId

compile_opt idl2

userBase = widget_info(baseId,find_by_uname='krsbub')
widget_control, userBase, get_uvalue=object
object->realize, userBase

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBaseDying, baseId

compile_opt idl2

widget_control, baseId, get_uvalue=self
obj_destroy, self

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase::toggleShowHide, event

compile_opt idl2

if event.press ge 1 then return

geom = widget_info(self.base,/geometry)

if self.visible eq 1 then begin
  widget_control,widget_info(self.base,find_by_uname='krsbub'),map=0
  case self.side of
  'left' : begin
            offset = 0
            step = self.step
            ;the final size to shrink to is dependent upon whether the base can be resized or not
            for i=geom.xsize,self.shrinkSize,-step do begin
              widget_control,self.base,xsize=i
              widget_control, self.lineBase, xoffset=self.restoreXsize-offset
              offset = offset+step
            endfor
            widget_control,self.base,xsize=self.shrinksize ;tweak it
            ;check to make sure the offset is right
            geom = widget_info(self.linebase,/geom)
            if geom.xoffset ne 0.0 then widget_control, self.lineBase, xoffset=0
            end
  'right' : begin
            offset = 0
            step = self.step
            device,get_screen_size=scrSize
            lineGeom = widget_info(self.linebase,/geom)
            offset = scrSize[0] - self.restoreXsize - lineGeom.scr_xsize
            for i=geom.xsize,self.shrinkSize,-step do begin
              widget_control,self.base,xsize=i
              widget_control, self.base, tlb_set_xoffset=offset
              offset = offset + step
            endfor
            ;check to make sure the offset is right
            geom = widget_info(self.linebase,/geom)
            if geom.xoffset ne 0.0 then widget_control, self.lineBase, xoffset=0
            end
  'top'     : begin
            offset = 0
            step = 20
            ;the final size to shrink to is dependent upon whether the base can be resized or not
            for i=geom.ysize,self.shrinkSize,-step do begin
              widget_control,self.base,ysize=i
              ;widget_control, self.lineBase, xoffset=self.restoreXsize-offset
              ;offset = offset+step
            endfor
            ;final nudge
            widget_control,self.base,ysize=self.shrinkSize
            end        
  endcase
  self.visible = 0
endif else begin
  widget_control,widget_info(self.base,find_by_uname='krsbub'),map=1
  case self.side of
  'left' : begin
           widget_control,self.base,xsize=self.shrinkSize + self.restoreXsize
           widget_control, self.lineBase, xoffset=self.restoreXsize
           end
  'right': begin
           widget_control,self.base,xsize=self.shrinkSize + self.restoreXsize
           device,get_screen_size=scrSz
           widget_control, self.base, tlb_set_xoffset = scrSz[0] - self.restoreXsize - 12
           widget_control,self.lineBase,xoffset=0
           end
  'top' :  begin
         widget_control,self.base,ysize=self.shrinkSize + self.restoreYsize
         end          
  endcase
  self.visible = 1
endelse

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSlidingBase::createBarImage,xsize, ysize, oWin=oWin
;creates the stippled looking bar image

compile_opt idl2

image = bytarr(3,xsize, ysize)
colors = widget_info(widget_base(),/system_colors)
image[0,*,*] = self.color[0]
image[1,*,*] = self.color[1]
image[2,*,*] = self.color[2]
image[*,0,*] = 0B
image[*,xsize-1,*] = 0B
image[*,*,0] = 0B
image[*,*,ysize-1] = 0B
longDim = xsize > ysize
shortDim = xsize < ysize
indices = lindgen(longDim/4)*4 + 1
if shortDim eq xsize then begin
  image[*,shortDim/2-1,indices] = 255B
  image[*,shortDim/2,indices+1] = 0B
  if keyword_set(oWin) then oWin->setCurrentCursor,'size_ew'
endif else begin
  image[*,indices,shortDim/2-1] = 255B
  image[*,indices+1,shortDim/2] = 0B
  if keyword_set(oWin) then oWin->setCurrentCursor,'size_ns'
endelse

return, image
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase::realize, userBase

compile_opt idl2

;find out how big it is
geom = widget_info(self.base,/geometry)

if self.side eq 'left' or self.side eq 'right' then begin
  xsize = 8
  ysize = geom.scr_ysize
  ;if the base is set to not move we need some more room for the Bar
  if geom.xsize eq geom.scr_xsize then begin
    self.shrinkSize = 16
    widget_control, self.base, scr_xsize=geom.scr_xsize + 16
  endif else self.shrinkSize = 8
  self.restoreXsize = geom.xsize
  ;move the bases
  if self.side eq 'left' then begin
    widget_control,self.lineBase,xoffset=self.restoreXsize
  endif else begin
    device,get_screen_size=scrSz
    widget_control,self.base,xsize=geom.scr_xsize + xsize
    widget_control, self.base, tlb_set_xoffset = scrSz[0] - geom.scr_xsize - xsize
    widget_control,self.lineBase,xoffset=0
    widget_control,widget_info(self.base,find_by_uname='krsbub'),xoffset=xsize
  endelse
endif else begin  ;top
  xsize = geom.scr_xsize
  ysize = 8
  ;if the base is set to not move we need some more room for the Bar
  if geom.ysize eq geom.scr_ysize then begin
    self.shrinkSize = 16
    widget_control, self.base, scr_ysize=geom.scr_ysize + 16
  endif else self.shrinkSize = 8
  self.restoreYsize = geom.ysize
  widget_control, userBase, yoffset=ysize
  widget_control,self.lineBase,yoffset=0 ;self.restoreYsize
endelse
  
widget_control, self.drawID, draw_ysize=ysize, draw_xsize=xsize
widget_control, self.drawID, get_value=oWin
self.oWin = oWin
image = self->createBarImage(xsize, ysize, oWin=self.oWin)
oModel = obj_new('IDLgrModel')
oImage = obj_new('IDLgrImage',image,interleave=0)
oView = obj_new('IDLgrView',viewplane_rect=[0,0,xsize, ysize])
oModel->add, oImage
oView -> add, oModel
self.oWin->draw, oView
self.oContainer->add,[oView, oModel, oImage]
;make it slide over if it is supposed to start out there
if self.visible eq 0 then begin
  self.visible=1
  self->toggleShowHide,{press:0}
endif

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase::getProperty, visible=visible, ysize=ysize

compile_opt idl2

if arg_present(visible) then visible=self.visible
if arg_present(ysize) then begin
  oImage = self.oContainer->get(/all,isa='IDLGRIMAGE')
  oImage->getProperty, data=image
  sz = size(image,/dimen)
  ysize = sz[2]
endif

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase::setProperty, xsize=xsize, ysize=ysize, map=map

compile_opt idl2

if keyword_set(xsize) then begin
  oView = self.oContainer->get(/all,isa='IDLGRVIEW')
  oImage = self.oContainer->get(/all,isa='IDLGRIMAGE')
  oImage->getProperty, data=image
  sz = size(image,/dimen)
  ysize = sz[2]
  image = self->createBarImage(xsize, ysize, oWin=self.oWin)
  widget_control, self.drawID, draw_ysize=ysize, draw_xsize=xsize
  oImage->setProperty, data=image
  oView->setProperty, viewplane_rect=[0,0,xsize, ysize]
  self.oWin->draw, oView
endif

if keyword_set(ysize) then begin
  oView = self.oContainer->get(/all,isa='IDLGRVIEW')
  oImage = self.oContainer->get(/all,isa='IDLGRIMAGE')
  oImage->getProperty, data=image
  sz = size(image,/dimen)
  xsize = sz[1]
  image = self->createBarImage(xsize, ysize, oWin=self.oWin)
  widget_control, self.drawID, draw_ysize=ysize, draw_xsize=xsize
  oImage->setProperty, data=image
  oView->setProperty, viewplane_rect=[0,0,xsize, ysize]
  self.oWin->draw, oView
endif

if n_elements(map) ne 0 then widget_control, self.base,map=map

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase::addBar

compile_opt idl2

self.lineBase = widget_base(self.base)
;add a window
xsize = 8
self.drawID = widget_draw(self.lineBase,xsize=xsize,ysize=xsize, $
                          graphics_level=2,retain=2, /button_events, $
                          event_pro='krSlidingBaseEvent',uvalue='toggleShowHide')
return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSlidingBase::init,  widgetID=widgetID, row=row, column=column, $
                               userBase=userBase,uvalue=uvalue, $
                               uname=uname, side=side, yoffset=yoffset, $
                               xoffset=xoffset, $
                               title=title, group_leader=group_leader, $
                               tlb_frame_attr=tlb_frame_attr, tlb_move_event=tlb_move_event, $
                               visible=visible, color=color, step=step, $
                               attachedToGroupLeader=attachedToGroupLeader, _extra=extra

compile_opt idl2

if n_elements(color) eq 0 then color=[255B,0B,0B]
if n_elements(visible) eq 0 then visible=1
;default is left side
if not keyword_set(side) then side='left'
self.side = strlowcase(side)
if not keyword_set(tlb_frame_attr) then tlb_frame_attr= (self.side eq 'left' ? 17 : 1)
;right side bases cannot have the 16 for the base not moving
if self.side ne 'left' then begin
  if tlb_frame_attr - 16 gt 0 then tlb_frame_attr=tlb_frame_attr-16
endif
if n_elements(step) eq 0 then step=2
self.step = step

;have to create the container early
self.oContainer = obj_new('IDL_container')

;top level base here
if not keyword_set(attachedToGroupLeader) then begin
  self.base = widget_base(func_get_value='krSlidingBaseGet', $
                          pro_set_value='krSlidingBaseSet', uvalue=uvalue, $
                          uname=uname,event_func='krSlidingBaseEvent', $
                          notify_realize = 'krSlidingBaseRealize', tlb_move_event=tlb_move_event, $
                          title=title, tlb_frame_attr=tlb_frame_attr, floating=keyword_set(group_leader), $
                          xpad = 0, space=0, xoffset=xoffset, yoffset=yoffset,group_leader=group_leader, $
                          _extra=extra)
endif else begin                          
  self.base = widget_base(group_leader, func_get_value='krSlidingBaseGet', $
                          pro_set_value='krSlidingBaseSet', uvalue=uvalue, $
                          uname=uname,event_func='krSlidingBaseEvent', $
                          ;notify_realize = 'krSlidingBaseRealize', tlb_move_event=tlb_move_event, $
                          ;title=title, tlb_frame_attr=tlb_frame_attr,  $
                          ;xpad = 0, space=0, xoffset=xoffset, yoffset=10, $
                          _extra=extra)
endelse                        
                        
if self.side eq 'top' then self->addBar
if self.side eq 'right' then self->addBar
userBase = widget_base(self.base,row=row,column=column, uname='krsbub',$
                       kill_notify='krSlidingBaseDying', uvalue=self)
if self.side eq 'left' then self->addBar

widgetID = self.base

;start out visible?
self.visible = visible
self.color = color

;if keyword_set(attachedToGroupLeader) then self->realize

return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase::cleanup

compile_opt idl2

obj_destroy, self.oContainer

return & end


;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro krSlidingBase__define

compile_opt idl2

object = {krSlidingBase, $
         parent : 0L, $
         base : 0L, $
         lineBase : 0L, $
         drawID : 0L, $
         oWin : obj_new(), $
         margin : 0, $
         orientation : '', $
         visible : '', $
         restoreXsize : 0L, $
         restoreYsize : 0L, $
         shrinkSize : 0, $
         step : 0, $
         side : '', $
         color : bytarr(3), $
         oContainer : obj_new() }

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function krSlidingBase, userBase=userBase, objRef=objRef, _extra=extra

compile_opt idl2

if n_params() ne 0 then begin
  message,'krSlidingBase must be the top level base'
  return,0L
endif

objRef = obj_new('krSlidingBase', widgetID=widgetID, $
                  userBase=userBase, _extra=extra)

return, widgetID
end