pro testKRSlidingBase_event, event
widget_control,event.top, get_uvalue=state
case event.id of
state.sinId : plot, sin(findgen(360)*!dtor),xmargin=[0,0],ymargin=[0,0]
state.cosId : plot, cos(findgen(360)*!dtor),xmargin=[0,0],ymargin=[0,0]
else :
endcase

return
end

;------------------------------------------------

pro testKRSlidingBase

wBase = widget_base(row=1, xoffset=0)
wDraw = widget_draw(wBase, xsize=50,ysize=300)

widget_control, wBase,/realize

;1 Base cannot be resized, minimized, or maximized. 
;2 Suppress display of system menu. 
;4 Suppress title bar. 
;8 Base cannot be closed. 
;16 Base cannot be moved. 
 
tlb_frame_attr=(1+2+4+16)
tlb_frame_attr=(1+2+4)

;each block is for a different way of laying out the sliding base
;topLevelBase = krSlidingBase(title='Kling Research Sliding Base', $
;                     userBase=userBase, column=1, yoffset=50, side='left', $
;                     tlb_frame_attr=tlb_frame_attr, group_leader=wBase)
;sinId = widget_button(userBase,value='Plot Sine Wave',uvalue='sin')
;cosId = widget_button(userBase,value='Plot Cosine Wave',uvalue='cos')
;drawId = widget_draw(userBase)
;widget_control, topLevelBase, /realize
;
;topLevelBase = krSlidingBase(title='Kling Research Sliding Base', $
;                     userBase=userBase, column=1, yoffset=50, side='right', $
;                     tlb_frame_attr=tlb_frame_attr, group_leader=wBase)
;sinId = widget_button(userBase,value='Plot Sine Wave',uvalue='sin')
;cosId = widget_button(userBase,value='Plot Cosine Wave',uvalue='cos')
;drawId = widget_draw(userBase)
;widget_control, topLevelBase, /realize

topLevelBase = krSlidingBase(title='Kling Research Sliding Base', $
                     userBase=userBase, column=1, xoffset=0, side='left', $
                     tlb_frame_attr=tlb_frame_attr, group_leader=wBase, color=[0,255,0])
sinId = widget_button(userBase,value='Plot Sine Wave',uvalue='sin')
cosId = widget_button(userBase,value='Plot Cosine Wave',uvalue='cos')
drawId = widget_draw(userBase)

widget_control, topLevelBase, /realize

state = {sinId:sinId, cosId:cosId, drawId:drawId}
widget_control,topLevelBase,set_uvalue=state
xmanager,'testKRSlidingBase',topLevelBase,/no_block

return
end